Index: issm/trunk/test/NightlyRun/test608.m
===================================================================
--- issm/trunk/test/NightlyRun/test608.m	(revision 12709)
+++ issm/trunk/test/NightlyRun/test608.m	(revision 13395)
@@ -4,11 +4,10 @@
 md=setflowequation(md,'macayeal','all');
 md.cluster=generic('name',oshostname(),'np',3);
-md=solve(md,SurfaceSlopeSolutionEnum);
+md=solve(md,BalancethicknessSolutionEnum);
 
 %Fields and tolerances to track changes
-field_names     ={'SurfaceSlopeX','SurfaceSlopeY'};
-field_tolerances={1e-13,1e-13};
+field_names     ={'Thickness'};
+field_tolerances={1e-13};
 field_values={...
-	(md.results.SurfaceSlopeSolution.SurfaceSlopeX),...
-	(md.results.SurfaceSlopeSolution.SurfaceSlopeY),...
+	(md.results.BalancethicknessSolution.Thickness),...
 	};
Index: issm/trunk/test/NightlyRun/test609.m
===================================================================
--- issm/trunk/test/NightlyRun/test609.m	(revision 13395)
+++ issm/trunk/test/NightlyRun/test609.m	(revision 13395)
@@ -0,0 +1,15 @@
+md=triangle(model,'../Exp/79North.exp',10000);
+md=meshconvert(md);
+md=setmask(md,'../Exp/79NorthShelf.exp','');
+md=parameterize(md,'../Par/79North.par');
+md=setflowequation(md,'macayeal','all');
+md.balancethickness.stabilization=3;
+md.cluster=generic('name',oshostname(),'np',3);
+md=solve(md,BalancethicknessSolutionEnum);
+
+%Fields and tolerances to track changes
+field_names     ={'Thickness'};
+field_tolerances={1e-13};
+field_values={...
+	(md.results.BalancethicknessSolution.Thickness),...
+	};
Index: issm/trunk/test/NightlyRun/test610.m
===================================================================
--- issm/trunk/test/NightlyRun/test610.m	(revision 12709)
+++ issm/trunk/test/NightlyRun/test610.m	(revision 13395)
@@ -2,14 +2,13 @@
 md=setmask(md,'../Exp/79NorthShelf.exp','');
 md=parameterize(md,'../Par/79North.par');
-md=extrude(md,5,1.5);
-md=setflowequation(md,'pattyn','all');
+md=extrude(md,3,1);
+md=setflowequation(md,'macayeal','all');
 md.cluster=generic('name',oshostname(),'np',3);
-md=solve(md,SurfaceSlopeSolutionEnum);
+md=solve(md,BalancethicknessSolutionEnum);
 
 %Fields and tolerances to track changes
-field_names     ={'SurfaceSlopeX','SurfaceSlopeY'};
-field_tolerances={1e-13,1e-13};
+field_names     ={'Thickness'};
+field_tolerances={1e-13};
 field_values={...
-	(md.results.SurfaceSlopeSolution.SurfaceSlopeX),...
-	(md.results.SurfaceSlopeSolution.SurfaceSlopeY),...
+	(md.results.BalancethicknessSolution.Thickness),...
 	};
Index: issm/trunk/test/NightlyRun/test611.m
===================================================================
--- issm/trunk/test/NightlyRun/test611.m	(revision 13395)
+++ issm/trunk/test/NightlyRun/test611.m	(revision 13395)
@@ -0,0 +1,31 @@
+md=triangle(model,'../Exp/79North.exp',10000);
+md=setmask(md,'../Exp/79NorthShelf.exp','');
+md=parameterize(md,'../Par/79North.par');
+md=setflowequation(md,'macayeal','all');
+
+%control parameters
+md.inversion.nsteps=2;
+md.prognostic.stabilization=1;
+md.inversion.iscontrol=1;
+md.inversion.control_parameters={'BalancethicknessThickeningRate'};
+md.inversion.thickness_obs=md.geometry.thickness;
+md.inversion.min_parameters=-50*ones(md.mesh.numberofvertices,1);
+md.inversion.max_parameters=50*ones(md.mesh.numberofvertices,1);
+md.inversion.cost_functions=201*ones(md.inversion.nsteps,1);
+md.inversion.cost_functions_coefficients=ones(md.mesh.numberofvertices,1);
+md.inversion.gradient_scaling=10/md.constants.yts*ones(md.inversion.nsteps,1);
+md.inversion.maxiter_per_step=4*ones(md.inversion.nsteps,1);
+md.inversion.step_threshold=0.99*ones(md.inversion.nsteps,1);
+
+md.cluster=generic('name',oshostname(),'np',3);
+md=solve(md,BalancethicknessSolutionEnum);
+
+%Fields and tolerances to track changes
+field_names     ={'Gradient' 'Misfits' 'BalancethicknessThickeningRate' 'Thickness'};
+field_tolerances={1e-12,1e-12,1e-12,1e-12,1e-12,1e-12};
+field_values={...
+	(md.results.BalancethicknessSolution.Gradient1),...
+	md.results.BalancethicknessSolution.J,...
+	(md.results.BalancethicknessSolution.BalancethicknessThickeningRate),...
+	(md.results.BalancethicknessSolution.Thickness)
+};
Index: issm/trunk/test/NightlyRun/test612.m
===================================================================
--- issm/trunk/test/NightlyRun/test612.m	(revision 12709)
+++ issm/trunk/test/NightlyRun/test612.m	(revision 13395)
@@ -1,14 +1,32 @@
 md=triangle(model,'../Exp/79North.exp',10000);
+md=meshconvert(md);
 md=setmask(md,'../Exp/79NorthShelf.exp','');
 md=parameterize(md,'../Par/79North.par');
 md=setflowequation(md,'macayeal','all');
+
+%control parameters
+md.inversion.nsteps=2;
+md.balancethickness.stabilization=3;
+md.inversion.iscontrol=1;
+md.inversion.control_parameters={'BalancethicknessThickeningRate'};
+md.inversion.thickness_obs=md.geometry.thickness;
+md.inversion.min_parameters=-50*ones(md.mesh.numberofvertices,1);
+md.inversion.max_parameters=50*ones(md.mesh.numberofvertices,1);
+md.inversion.cost_functions=201*ones(md.inversion.nsteps,1);
+md.inversion.cost_functions_coefficients=ones(md.mesh.numberofvertices,1);
+md.inversion.gradient_scaling=10/md.constants.yts*ones(md.inversion.nsteps,1);
+md.inversion.maxiter_per_step=4*ones(md.inversion.nsteps,1);
+md.inversion.step_threshold=0.99*ones(md.inversion.nsteps,1);
+
 md.cluster=generic('name',oshostname(),'np',3);
-md=solve(md,BedSlopeSolutionEnum);
+md=solve(md,BalancethicknessSolutionEnum);
 
 %Fields and tolerances to track changes
-field_names     ={'BedSlopeX','BedSlopeY'};
-field_tolerances={1e-13,1e-13};
+field_names     ={'Gradient' 'Misfits' 'BalancethicknessThickeningRate' 'Thickness'};
+field_tolerances={1e-12,1e-12,1e-12,1e-12,1e-12,1e-12};
 field_values={...
-	(md.results.BedSlopeSolution.BedSlopeX),...
-	(md.results.BedSlopeSolution.BedSlopeY),...
-	};
+	(md.results.BalancethicknessSolution.Gradient1),...
+	md.results.BalancethicknessSolution.J,...
+	(md.results.BalancethicknessSolution.BalancethicknessThickeningRate),...
+	(md.results.BalancethicknessSolution.Thickness)
+};
Index: issm/trunk/test/NightlyRun/test613.m
===================================================================
--- issm/trunk/test/NightlyRun/test613.m	(revision 13395)
+++ issm/trunk/test/NightlyRun/test613.m	(revision 13395)
@@ -0,0 +1,41 @@
+md=triangle(model,'../Exp/79North.exp',10000);
+md=meshconvert(md);
+md=setmask(md,'../Exp/79NorthShelf.exp','');
+md=parameterize(md,'../Par/79North.par');
+md=setflowequation(md,'macayeal','all');
+
+%Ice sheet only
+md=extract(md,md.mask.elementongroundedice);
+pos=find(md.mesh.vertexonboundary);
+md.balancethickness.spcthickness(pos)=md.geometry.thickness(pos);
+
+%control parameters
+md.inversion.thickness_obs=md.geometry.thickness;
+md.inversion.iscontrol=1;
+md.inversion.thickness_obs=md.geometry.thickness;
+md.inversion.nsteps=2;
+md.inversion.control_parameters={'Vx' 'Vy'};
+md.balancethickness.stabilization=1;
+md.inversion.gradient_scaling=[10/md.constants.yts*ones(md.inversion.nsteps,1) 10/md.constants.yts*ones(md.inversion.nsteps,1)];
+md.inversion.min_parameters=[-2000*ones(md.mesh.numberofvertices,1) -2000*ones(md.mesh.numberofvertices,1)];
+md.inversion.max_parameters=[+2000*ones(md.mesh.numberofvertices,1) +2000*ones(md.mesh.numberofvertices,1)];
+md.inversion.cost_functions=201*ones(md.inversion.nsteps,1);
+md.inversion.cost_functions_coefficients=ones(md.mesh.numberofvertices,1);
+md.inversion.maxiter_per_step=4*ones(md.inversion.nsteps,1);
+md.inversion.step_threshold=0.99*ones(md.inversion.nsteps,1);
+
+md.verbose.control=1;
+md.cluster=generic('name',oshostname(),'np',3);
+md=solve(md,BalancethicknessSolutionEnum);
+
+%Fields and tolerances to track changes
+field_names     ={'Gradient1' 'Gradient2' 'Misfits' 'Vx' 'Vy' 'Thickness'};
+field_tolerances={1e-12,1e-12,1e-12,1e-12,1e-12,1e-12};
+field_values={...
+	(md.results.BalancethicknessSolution.Gradient1),...
+	(md.results.BalancethicknessSolution.Gradient2),...
+	md.results.BalancethicknessSolution.J,...
+	(md.results.BalancethicknessSolution.Vx),...
+	(md.results.BalancethicknessSolution.Vy),...
+	(md.results.BalancethicknessSolution.Thickness)
+};
Index: issm/trunk/test/Par/79North.par
===================================================================
--- issm/trunk/test/Par/79North.par	(revision 12709)
+++ issm/trunk/test/Par/79North.par	(revision 13395)
@@ -2,5 +2,11 @@
 
 %Geometry and observation
-load('../Data/79North.data','-mat');
+x=transpose(ncread('../Data/79North.nc','x'));
+y=transpose(ncread('../Data/79North.nc','y'));
+vx=transpose(ncread('../Data/79North.nc','vx'));
+vy=transpose(ncread('../Data/79North.nc','vy'));
+index=transpose(ncread('../Data/79North.nc','index'));
+surface=transpose(ncread('../Data/79North.nc','surface'));
+thickness=transpose(ncread('../Data/79North.nc','thickness'));
 md.initialization.vx       =InterpFromMeshToMesh2d(index,x,y,vx,md.mesh.x,md.mesh.y);
 md.initialization.vy       =InterpFromMeshToMesh2d(index,x,y,vy,md.mesh.x,md.mesh.y);
Index: issm/trunk/test/Par/ISMIPE.par
===================================================================
--- issm/trunk/test/Par/ISMIPE.par	(revision 12709)
+++ issm/trunk/test/Par/ISMIPE.par	(revision 13395)
@@ -2,6 +2,5 @@
 
 disp('      creating thickness');
-data=load('../Data/ISMIPE.data','-mat');
-data=data.data;
+data=transpose(ncread('../Data/ISMIPE.nc','data'));
 md.geometry.surface=zeros(md.mesh.numberofvertices,1);
 md.geometry.bed=zeros(md.mesh.numberofvertices,1);
Index: issm/trunk/test/Par/Pig.par
===================================================================
--- issm/trunk/test/Par/Pig.par	(revision 12709)
+++ issm/trunk/test/Par/Pig.par	(revision 13395)
@@ -2,5 +2,11 @@
 
 %Geometry and observation
-load('../Data/Pig.data','-mat');
+x         = transpose(ncread('../Data/Pig.nc','x'));
+y         = transpose(ncread('../Data/Pig.nc','y'));
+vx_obs    = transpose(ncread('../Data/Pig.nc','vx_obs'));
+vy_obs    = transpose(ncread('../Data/Pig.nc','vy_obs'));
+index     = transpose(ncread('../Data/Pig.nc','index'));
+surface   = transpose(ncread('../Data/Pig.nc','surface'));
+thickness = transpose(ncread('../Data/Pig.nc','thickness'));
 md.inversion.vx_obs   =InterpFromMeshToMesh2d(index,x,y,vx_obs,md.mesh.x,md.mesh.y);
 md.inversion.vy_obs   =InterpFromMeshToMesh2d(index,x,y,vy_obs,md.mesh.x,md.mesh.y);
Index: issm/trunk/test/Par/SquareSheetConstrained.par
===================================================================
--- issm/trunk/test/Par/SquareSheetConstrained.par	(revision 12709)
+++ issm/trunk/test/Par/SquareSheetConstrained.par	(revision 13395)
@@ -11,5 +11,9 @@
 
 %Initial velocity 
-load('../Data/SquareSheetConstrained.data','-mat');
+x     = transpose(ncread('../Data/SquareSheetConstrained.nc','x'));
+y     = transpose(ncread('../Data/SquareSheetConstrained.nc','y'));
+vx    = transpose(ncread('../Data/SquareSheetConstrained.nc','vx'));
+vy    = transpose(ncread('../Data/SquareSheetConstrained.nc','vy'));
+index = transpose(ncread('../Data/SquareSheetConstrained.nc','index'));
 md.initialization.vx=InterpFromMeshToMesh2d(index,x,y,vx,md.mesh.x,md.mesh.y);
 md.initialization.vy=InterpFromMeshToMesh2d(index,x,y,vy,md.mesh.x,md.mesh.y);
Index: issm/trunk/test/Par/SquareSheetShelf.par
===================================================================
--- issm/trunk/test/Par/SquareSheetShelf.par	(revision 12709)
+++ issm/trunk/test/Par/SquareSheetShelf.par	(revision 13395)
@@ -14,5 +14,9 @@
 
 %Initial velocity 
-load('../Data/SquareSheetShelf.data','-mat');
+x     = transpose(ncread('../Data/SquareSheetShelf.nc','x'));
+y     = transpose(ncread('../Data/SquareSheetShelf.nc','y'));
+vx    = transpose(ncread('../Data/SquareSheetShelf.nc','vx'));
+vy    = transpose(ncread('../Data/SquareSheetShelf.nc','vy'));
+index = transpose(ncread('../Data/SquareSheetShelf.nc','index'));
 md.initialization.vx=InterpFromMeshToMesh2d(index,x,y,vx,md.mesh.x,md.mesh.y);
 md.initialization.vy=InterpFromMeshToMesh2d(index,x,y,vy,md.mesh.x,md.mesh.y);
Index: issm/trunk/test/Par/SquareShelf.par
===================================================================
--- issm/trunk/test/Par/SquareShelf.par	(revision 12709)
+++ issm/trunk/test/Par/SquareShelf.par	(revision 13395)
@@ -11,5 +11,9 @@
 
 %Initial velocity and pressure
-load('../Data/SquareShelf.data','-mat');
+x     = transpose(ncread('../Data/SquareShelf.nc','x'));
+y     = transpose(ncread('../Data/SquareShelf.nc','y'));
+vx    = transpose(ncread('../Data/SquareShelf.nc','vx'));
+vy    = transpose(ncread('../Data/SquareShelf.nc','vy'));
+index = transpose(ncread('../Data/SquareShelf.nc','index'));
 md.initialization.vx=InterpFromMeshToMesh2d(index,x,y,vx,md.mesh.x,md.mesh.y);
 md.initialization.vy=InterpFromMeshToMesh2d(index,x,y,vy,md.mesh.x,md.mesh.y);
Index: issm/trunk/test/Par/SquareShelfConstrained.par
===================================================================
--- issm/trunk/test/Par/SquareShelfConstrained.par	(revision 12709)
+++ issm/trunk/test/Par/SquareShelfConstrained.par	(revision 13395)
@@ -11,5 +11,9 @@
 
 %Initial velocity 
-load('../Data/SquareShelfConstrained.data','-mat');
+x     = transpose(ncread('../Data/SquareShelfConstrained.nc','x'));
+y     = transpose(ncread('../Data/SquareShelfConstrained.nc','y'));
+vx    = transpose(ncread('../Data/SquareShelfConstrained.nc','vx'));
+vy    = transpose(ncread('../Data/SquareShelfConstrained.nc','vy'));
+index = transpose(ncread('../Data/SquareShelfConstrained.nc','index'));
 md.initialization.vx=InterpFromMeshToMesh2d(index,x,y,vx,md.mesh.x,md.mesh.y);
 md.initialization.vy=InterpFromMeshToMesh2d(index,x,y,vy,md.mesh.x,md.mesh.y);
@@ -50,5 +54,5 @@
 md=SetIceShelfBC(md);
 
-%Change name so that no test have the same name
+%Change name so that no tests have the same name
 A=dbstack;
 if (length(A)>2), md.miscellaneous.name=A(3).file(1:end-2); end
Index: issm/trunk/test/Par/SquareShelfConstrained.py
===================================================================
--- issm/trunk/test/Par/SquareShelfConstrained.py	(revision 12709)
+++ issm/trunk/test/Par/SquareShelfConstrained.py	(revision 13395)
@@ -1,7 +1,10 @@
+import os.path
+import inspect
+import netCDF4
 from numpy import *
 from verbose import *
-import scipy.io as matio
-import InterpFromMeshToMesh2d as im
-from   paterson import  *
+from InterpFromMeshToMesh2d import InterpFromMeshToMesh2d
+from paterson import *
+from SetIceShelfBC import *
 
 #Start defining model parameters here
@@ -13,15 +16,21 @@
 
 md.geometry.thickness = hmax+(hmin-hmax)*(md.mesh.y-ymin)/(ymax-ymin)
-md.geometry.bed=-md.materials.rho_ice/md.materials.rho_water*md.geometry.thickness;
+md.geometry.bed=-md.materials.rho_ice/md.materials.rho_water*md.geometry.thickness
 md.geometry.surface = md.geometry.bed+md.geometry.thickness
 
 #Initial velocity 
-mat=matio.loadmat('../Data/SquareShelfConstrained.data')
+f = netCDF4.Dataset('../Data/SquareShelfConstrained.nc','r')
+#Reshape as Rank-1 arrays
+x=reshape(f.variables['x'][:],(-1))
+y=reshape(f.variables['y'][:],(-1))
+vx=f.variables['vx'][:]
+vy=f.variables['vy'][:]
 #deal with 'F' oriented matlab matrices!
-index=mat['index'].astype(float)
+index=f.variables['index'][:].astype(float)
 index=reshape(index.T,(len(index),3),order='F')
+f.close()
 
-md.initialization.vx = im.InterpFromMeshToMesh2d(index, mat['x'], mat['y'], mat['vx'], md.mesh.x, md.mesh.y)
-md.initialization.vy = im.InterpFromMeshToMesh2d(index, mat['x'], mat['y'], mat['vy'], md.mesh.x, md.mesh.y)
+[md.initialization.vx] = InterpFromMeshToMesh2d(index, x, y, vx, md.mesh.x, md.mesh.y)
+[md.initialization.vy] = InterpFromMeshToMesh2d(index, x, y, vy, md.mesh.x, md.mesh.y)
 md.initialization.vz = zeros(md.mesh.numberofvertices)
 md.initialization.pressure = zeros(md.mesh.numberofvertices)
@@ -53,7 +62,6 @@
 #Deal with boundary conditions:
 md = SetIceShelfBC(md)
-#Change name so that no test have the same name
-A = dbstack
-if length(A) > 2.:
-    md.miscellaneous.name = A[2].file[0:0-2.]
+#Change name so that no tests have the same name
+if len(inspect.stack()) > 2:
+	md.miscellaneous.name = os.path.basename(inspect.stack()[2][1]).split('.')[0]
 
